/*
	Felldefinilt metdusok toString(), keruletSzamit(), teruletSzamit()
	Futs idej kts  - ksi kts, (runtime binding - late binding)
*/
public class Sikidom {

	/*
		Mdostunk a hozzfrsi lehetsgeken, de gy a
		szrmaztatott osztlyokat is mdostani kell majd.
	*/
	private double kerulet, terulet;
	private boolean keruletKiszamitva = false;  
	private boolean teruletKiszamitva = false;

	/*
		t kellett alaktani a metdust, de a mkds nem sokat mdosul;
		gy is csak egyszer kell a szmtst elvgezni, majd szksg esetn a trolt
		eredmnyt visszaadni.
	*/
	public double getKerulet() {
		if (!keruletKiszamitva) {
			//csak egyszer fut le a pldny lettartama alatt!
			kerulet = keruletSzamit();
			keruletKiszamitva = true;
		}
		return kerulet;
	}

	public double getTerulet () {
		if (!teruletKiszamitva) {
			terulet = teruletSzamit();
			teruletKiszamitva = true;
		}
		return terulet;
	}

	/*
		Mr az sosztlyban is ismertnek kell lennie a metdusoknak,
		mg ha nem is csinlnak semmit. 
		Megvltozott a visszatrsi
		rtk tpusa, s a hozzfrsi mdost is!
	*/
	protected double keruletSzamit() { return 0.; };
	protected double teruletSzamit() { return 0.; };
}