public class Szorzotabla {
	private final int maxMeret=20, minMeret=3;
	private int aktMeret;
	private int tabla[][];

	public Szorzotabla() {
		this(10);
	}

	public Szorzotabla(int aktMeret) {
		if(aktMeret <= maxMeret && aktMeret >= minMeret) {
			this.aktMeret = aktMeret;
		} else {
			this.aktMeret = 10;
		}
		feltolt();
	}

	private void feltolt() {
		tabla = new int [aktMeret][aktMeret];

		for(int i=0; i < aktMeret; i++) {
			for(int j=0; j < aktMeret; j++) {
				tabla[i][j] = (i + 1) * (j + 1);
			}
		}
	}

	public void kiir() {
		System.out.println("\n\nSzorztbla kirsa:\n");
		for(int i = 0; i < aktMeret; i++) {
			for(int j = 0; j < aktMeret; j++) {
				System.out.print(tabla[i][j] + "\t");
			}
			System.out.print("\n");
		}
	}

	public void kiirTablazat() {
		System.out.println("\n\nSzorztbla kirsa tblzatba:\n");
		vonalKi();
		for(int i = 0; i < aktMeret; i++) {
			for(int j = 0; j < aktMeret; j++) {
				System.out.print("\t" + tabla[i][j] + "\t|");
			}
			System.out.print("\n");
			vonalKi();
		}
	}

	public void kiirFejlecesTablazat() {
		System.out.println("\n\nSzorztbla kirsa fejlces tblzatba:\n");
		fejlecKi();
		for(int i = 0; i < aktMeret; i++) {
			System.out.print("\t" + (i + 1) + "\t||");
			for(int j = 0; j < aktMeret; j++) {
				System.out.print("\t" + tabla[i][j] + "\t|");
			}
			System.out.print("\n");
			vonalKi(1);
		}
	}

	private void vonalKi(int k,char s) {
		for(int i = 0; i < aktMeret+k; i++) {
			System.out.print("\t" + s + "\t+");
		}
		System.out.print("\n");
	}

	private void vonalKi(int k) {
		vonalKi(k, '-');
	}

	private void vonalKi() {
		vonalKi(0);
	}

	private void fejlecUresSorKi() {
		for(int i = 0; i < aktMeret+1; i++) {
			System.out.print("\t\t|");
		}
		System.out.print("\n");
	}

	private void fejlecKi() {
		vonalKi(1, '=');
		fejlecUresSorKi();
		System.out.print("\t\t|");
		for(int i = 0; i < aktMeret; i++) {
			System.out.print("\t" + (i + 1) + "\t|");
		}
		System.out.print("\n");
		fejlecUresSorKi();
		vonalKi(1, '=');
	}
}