/*
	Ktirnyban lncolt dinamikus listt megvalst osztly
	Bels staikus tagosztly, amely a kls szemll ell rejtve marad!
	Kompozci - ers tartalmazsi kapcsolat
*/
public class Lista {
	// A lista osztly egyetlen adattagja  - az albbiakban definilt - bels, statikus osztlybeli pldny
	// Ez lesz a lista kezd eleme.
	private Elem elso;

	/*
		Statikus bels osztly, csak a tartalmaz osztly ismeri
		a bels osztly elri a tartalmaz osztly privt tagjait is!
	*/
	private static class Elem {
		// a tagosztly adattagjai, a tartalmazott referencia
		// s a lncolshoz szksges referencia-mutatk.
		private Object adat;
		private Elem elozo, kovetkezo;

		// a tagosztly konstruktora
		Elem(Object adat, Elem elozo, Elem kovetkezo) {
			this.adat = adat;
			this.elozo = elozo;
			this.kovetkezo = kovetkezo;
		}
	}

	// A lista elejre (az els elem el) a beszur() metdussal tehetnk elemet
	public void beszur(Object adat) {
		elso = new Elem(adat, null, elso);
		if (elso.kovetkezo != null) {
			elso.kovetkezo.elozo = elso;
		}
	}

	// A lista vgre (az utols elem utn) a hozzazad() metdussal tehetnk elemet
	public void hozzaad(Object adat) {
		Elem akt = elso;
		if(akt != null) {
			while (akt.kovetkezo != null) {
				akt = akt.kovetkezo;
			}
			akt = new Elem(adat, akt, null);
			if(akt.elozo != null) {
				akt.elozo.kovetkezo = akt;
			}
		} else {
			elso = new Elem(adat, elso, null);
		}
	}

	// A listbl adott referencij elem trlse
	public void torol(Object adat) {
		Elem elem = keres(adat);
		if(elem != null) {
			torol(elem);
		} else {
			System.err.println("Ilyen elem nincs a listban!");
		}
	}

	// A listbl adott index elem trlse
	public void torol(int index) {
		if(elso != null) {
			Elem akt = elso;
			int i=0;
			while(i < index && akt.kovetkezo != null) {
				akt = akt.kovetkezo;
				i++;
			}
			if(akt != null && i == index) {
				torol(akt);
			} else {
				System.err.println("Ilyen index elem nincs a listban!");
			}
		} else {
			System.err.println("A lista res!");
		}
	}

	// A valdi trlst ez a metdus hajtja vgre. Kvlrl nem hvhat!
	private void torol(Elem elem) {
		if(elem == elso) {
			elso = elem.kovetkezo;
		}
		if(elem.elozo != null) {
			elem.elozo.kovetkezo = elem.kovetkezo;
		}
		if (elem.kovetkezo != null) {
			elem.kovetkezo.elozo = elem.elozo;
		}
		System.err.println("Egy elemet trltem a listbl.");
	}

	// Egy adott referencij elem kikeresse (szintn bels metdus)
	private Elem keres(Object adat) {
		for(Elem elem = elso; elem != null; elem = elem.kovetkezo) {
			if(elem.adat.equals(adat)) {
				return elem;
			}
		}
		return null;
	}

	// A felldefinilt toString metdus a lista bejrsval szvegknt adja vissza annak tartalmt.
	public String toString() {
		Elem akt = elso;
		if(akt != null) {
			StringBuffer visszateres = new StringBuffer("A lista tartalma: ");
			while(akt.kovetkezo != null) {
				visszateres.append(akt.adat).append(" -> ");
				akt = akt.kovetkezo;
			}
			visszateres.append(akt.adat).append(". ");
			return visszateres.toString();
		} else return "A lista res!";
	}
}