public class Ember {
	private String nev;
	private Agy agyvelo;
	private Kar jobbkar, balkar;

	/*
		Statikus tagosztly - nem tud a tartalmaz osztly adatairl (ember)
		azaz minden ember a fldn l
	*/
	private static class Elohely {
		private static String bolygo = "Fld";
		private static String faj = "homo sapiens";

		private static String getElohely() {
			return "lhelye: " + bolygo + " faja: " + faj;
		}

		private static void evolucio() {
			faj = "homo sapiens sapiens";
		}
	}

	/*
		Nem statikus tagosztly - mindent tud a tartalmaz osztly adatairl,
		azaz minden embernek sajt keze van
	*/
	private class Kar {
		private String karneve;

		private Kar(String neve) {
			karneve = neve;
		}

		private void mozgat() {
			System.out.println("Mozog a " + karneve);
		}
	}

	/*
		Nem statikus tagosztly - mindent tud a tartalmaz osztly adatairl,
		azaz irnytja az Ember rszeit.
	*/
	private class Agy {
		private void irasVezerles(String mit) {
			System.out.print("rshoz felkszlk: ");
			// az agy elri az Ember adattagjait, s zenetet kldhet neki
			Ember.this.jobbkar.mozgat();
			// az agy elri az Ember adattagjait, s zenetet kldhet neki
			System.out.println("Lertam: " + mit + " alrs: " + nev);
		}
	}

	//ez mr az Ember osztly konstruktora
	public Ember(String neve) {
		nev = neve;
		// Elrhet, mert statikus!
		// Elohely.bolygo;
		agyvelo = new Agy();
		jobbkar = new Kar("jobbkar");
		balkar = new Kar("balkar");
	}

	public void iras(String mit) {
		agyvelo.irasVezerles(mit);
	}

	public void mozgat(String melyik) {
		if(melyik == jobbkar.karneve) {
			jobbkar.mozgat();
		} else if(melyik == balkar.karneve) {
			balkar.mozgat();
		} else {
			System.out.println("Nem tudom mozgatni: " + melyik);
		}
	}

	public void evolucio() {
		Elohely.evolucio();
	}

	public String toString() {
		return "Nevem: " + nev + " " + Elohely.getElohely();
	}
}