/*
	Absztrakt Sikidom osztly
	Ha az osztly tartalmaz absztrakt metdust, akkor az osztlynak is absztraktnak kell lennie!
	Ksi kts - late binding
*/
public abstract class Sikidom {

	private double kerulet, terulet;
	private boolean keruletKiszamitva = false;
	private boolean teruletKiszamitva = false;

	// Figyeljk meg, hogy keruletSzamit() metdust csak ksbb deklarljuk!
	public double getKerulet() {
		if (!keruletKiszamitva) {
			kerulet = keruletSzamit();
			keruletKiszamitva = true;
		}
		return kerulet;
	}

	public double getTerulet () {
		if (!teruletKiszamitva) {
			terulet = teruletSzamit();
			teruletKiszamitva = true;
		}
		return terulet;
	}

	/*
		Most mr absztrakt metdusokat hasznlunk.
		gy sokkal elegnsabb. (Az sosztlyban mg nem tudjuk a kpletet, majd a leszrmazottban kifejtjk.)
	*/
	protected abstract double keruletSzamit();
	protected abstract double teruletSzamit();
}