/**
	A boltban tetszleges, de lland szm pnztr tallhat.
	Ezek nmelyike tmb segtsgvel, msok lncolt listval implementltak.
	A pnztrak referenciit ezentl hagyomnyos tmb helyett egy vektorban troljuk.
*/

import java.util.Vector;

public class Bolt {
	private Vector penztarak;
	private int penztarDb;

	/**
		Meghatrozott szm tmbbel s lncolt listval megvalstott pnztr ltrehozsa.
		@param tomb A tmb segtsgvel megvalstott pnztrak szma a boltban.
		@param lista A lncolt lista segtsgvel megvalstott pnztrak szma a boltban.
	*/
	public Bolt(int tomb, int lista) {
		penztarDb = tomb + lista;
		penztarak = new Vector(penztarDb);
		int i;
		for(i = 0; i < tomb; i++) {
			penztarak.add(new PenztarTomb());
		}
		for(; i < penztarDb; i++) {
			penztarak.add(new PenztarLista());
		}
	}

	/**
		Egy adott pnztr eltt vrakoz vsrlk sornak vghez j gyfl csatlakozik, aki
		adott rtk termkeket kvn megvenni.
		@param penztar A pnztr sorszma, ahol az gyfl sorban ll.
		@param ertek Ekkora sszeg termket kvn megvenni a vsrl.
	*/
	public void beall(int penztar, int ertek) {
		try {
			((Penztar)penztarak.get(penztar)).ujvasarlo(ertek);
		} catch (Exception e) {
			System.err.println(e);
		}
	}

	/**
		Az adott pnztrnl ll kuncsaftok kzl a legels kifizette a szmlt, majd tvozik.
		@param penztar Annak a pnztrnak a sorszma, ahol fizetni fog az els sorban ll gyfl.
	*/
	public void tavozik(int penztar) {
		try {
			((Penztar)penztarak.get(penztar)).fizet();
		} catch (Exception e) {
			System.err.println(e);
		}
	}

	/**
		Pnztrak adatainak megjelentse.
	*/
	public String toString() {
		StringBuffer sb = new StringBuffer("A bolt pnztrainak adatai:\n\n");
		for(int i = 0; i < penztarDb; i++) {
			sb.append("Index: " + i + "\n");
			sb.append("Tpus: " + penztarak.get(i).getClass() + "\n");
			sb.append("Tvoztak eddig: " + ((Penztar)penztarak.get(i)).getFizetettDb() + " f\n");
			sb.append("Sorban llnak most: " + ((Penztar)penztarak.get(i)).getSorbanallDb() + " f\n");
			sb.append("Befolyt sszeg: " + ((Penztar)penztarak.get(i)).getBevetel() + " Ft\n\n");
		}
		return sb.toString();
	}
}