/**
	A pnztrak absztakt s osztlya.
*/
public abstract class Penztar {
	/** Azon vsrlk szma, akik ennl a pnztrnl fizettek. */
	protected int vasarloTavozott;
	/** A jelenleg is a konkrt pnztrnl vrakoz vsrlk szma. */
	protected int vasarloVarakozik;
	/** A pnztrba eddig befolyt sszeg. */
	protected int befolytOsszeg;

	/** Adattagok nullzsa. */
	public Penztar() {
		vasarloTavozott = vasarloVarakozik = 0;
		befolytOsszeg = 0;
	}
	
	/**
		A pnztr eltt sorban ll vsrlkhoz egy jabb csatlakozik, a megadott rtk termkkel kosarban.
		@param ertek Az gyfl kosarban lv termk rtke.
		@throws Exception Ha valamirt nem llthat be a vsrl a sorba (pl. elfogyott a memria), kivtel keletkezik.
	*/
	public abstract void ujvasarlo(int ertek) throws Exception;

	/**
		A pnztr eltt sorban ll vsrlk kzl az els fizet, majd tvozik.
		@throws Exception Ha a pnztrnl senki nem ll sorban, nincs kinek fizetnie, amit kivtel jelez.
	*/
	public abstract void fizet() throws Exception;

	/** @return A sorban llk szmt szolgltatja. */
	public int getSorbanallDb() {
		return vasarloVarakozik;
	}

	/** @return Visszaadja, hogy eddig hny gyfl fizetett a pnztrnl. */
	public int getFizetettDb() {
		return vasarloTavozott;
	}

	/** @return A pnztrba eddig befolyt sszeget adja vissza. */
	public int getBevetel() {
		return befolytOsszeg;
	}
}