/**
	Dinamikus tmbbel megvalstott pnztr.
	Ezentl csak a rendelkezsre ll memria szabhat gtat a sorbanll vsrlk szmnak.
*/

import java.util.ArrayList;

public class PenztarTomb extends Penztar {
	private ArrayList vasarlok;

	/** Dinamikus tmb ltrehozsa, adattagok inicializlsa. */
	public PenztarTomb() {
		super();
		vasarlok = new ArrayList();
	}

	/**
		A pnztr eltt sorban ll vsrlkhoz egy jabb csatlakozik, a megadott rtk termkkel kosarban.
		@param ertek Az gyfl kosarban lv termk rtke.
		@throws Exception Ha valamirt nem llthat be a vsrl a sorba (pl. elfogyott a memria), kivtel keletkezik.
	*/
	public void ujvasarlo(int ertek) throws Exception {
		vasarlok.add(new Integer(ertek));
		vasarloVarakozik++;
	}

	/**
		A pnztr eltt sorban ll vsrlk kzl az els fizet, majd tvozik.
		@throws Exception Ha a pnztrnl senki nem ll sorban, nincs kinek fizetnie, amit kivtel jelez.
	*/
	public void fizet() throws Exception {
		if (vasarlok.isEmpty()) {
			throw new Exception("A sor res!");
		} else {
			befolytOsszeg += ((Integer)vasarlok.remove(0)).intValue();
			vasarloVarakozik--;
			vasarloTavozott++;
		}
	}
}