/*
	BitSet osztly hasznlatt bemutat plda
	Az osztly NEM valstja meg a Set interfszt.
*/
import java.util.*;

class BitSetTeszt {
	public static void main(String args[]) {
		final byte N = 50;
		// direkt rontom el -> dinamikus mret objektum
		BitSet paros = new BitSet(10);
		BitSet harommalOszthato = new BitSet();
		BitSet hattalOszthato = new BitSet();

		for (int i = 0; i < N; i += 2) {
			paros.set(i);
			hattalOszthato.set(i);
		}
		for (int i = 0; i < N; i += 3) {
			harommalOszthato.set(i);
		}
		hattalOszthato.and(harommalOszthato);

		System.out.println("Pros szmok: " + paros);
		System.out.println("Hrommal oszthat szmok: " + harommalOszthato);
		System.out.println("Hattal oszthat szmok: " + hattalOszthato);

		// ms megolds
		System.out.println("\n--------------------------\nUgyanez mskppen:");
		hattalOszthato.clear();
		// msols
		hattalOszthato = (BitSet)harommalOszthato.clone();
		hattalOszthato.and(paros);

		System.out.println("Pros szmok: " + paros);
		System.out.println("Hrommal oszthat szmok: " + harommalOszthato);
		System.out.println("Hattal oszthat szmok: " + hattalOszthato);

		// binris mveletekre is alkalmas a BitSet osztly
		System.out.println("\n--------------------------\nA BitSet felhasznlsa binris szmtsokra:");
		// elkszlnk egy 32 bites egsz trolsra
		BitSet bithalmaz = new BitSet(32);
		System.out.println(bithalmaz);
		// a 2. bitet (jobbrl a harmadik - bebillentem)
		// 100 = decimlis 4
		bithalmaz.set(2);
		System.out.println(bithalmaz);

		// adott bit rtkt kiszedhetem
		// false
		boolean b = bithalmaz.get(0);
		// true
		b = bithalmaz.get(2);
		System.out.println("A 2-es sorszm bit rtke: " + b);
		// adott bitet trlk - hamiss teszem
		bithalmaz.clear(1);
		// A bithalmaz egy adott rszhalmazt  kivehetem
		BitSet bithalmaz2 = new BitSet();
		// 1110
		bithalmaz2.set(1, 4);
		// kt bitsorozat sszadsa (eredmny a hvban keletkezik)
		// 0100
		bithalmaz.and(bithalmaz2);
		// kizr VAGY
		// 1010
		bithalmaz.xor(bithalmaz2);
		//minden egyes bit cserje - egyes komplemens
		// 0101
		bithalmaz.flip(0, bithalmaz.length());
		// ellentett hozzadsa
		// 0001
		bithalmaz.andNot(bithalmaz2);
		// binris vagy mvelet
		// 1111
		bithalmaz.or(bithalmaz2);
		System.out.println(bithalmaz);
	}
}