import java.util.*;

public class Nyilvantarto{
	private Set d;
		
	public Nyilvantarto(){
		d=new TreeSet();
	}
	
// --------------------- keress -----------------------	
	
	//szemly keresse szemlyi szm alapjn
	public Szemely getSzemelyBySzemSzam(String szsz){
		Iterator it=d.iterator();
		while(it.hasNext()){
			Szemely sz=(Szemely)it.next();
			if(sz.getSzemSzam().equals(szsz)) return sz;
		}
		return null;
	}
	
	//szemly keresse nv alapjn (tbb is lehet!)
	public Vector getSzemelyByNev(String nev){
		Vector v=new Vector();
		Iterator it=d.iterator();
		while(it.hasNext()){
			Szemely sz=(Szemely)it.next();
			if(sz.getNev().equals(nev)) v.add(sz);
		}
		return v;
	}

// ------------------ hozzads ------------------------
	
	//szemly objektum hozzadsa 
	public void addSzemely(Szemely sz){
		d.add(sz);
	}
	
	//szemly hozzadsa nvvel s szemlyi szmmal
	public void addSzemely(String nev, String szsz){
		addSzemely(new Szemely(nev,szsz));
	}
	
// ------------------ eltvolts ---------------------	
	
	//szemly eltvoltsa
	public void removeSzemely(Szemely sz){
		d.remove(sz);
	}
	
	//szemly eltvoltsa szemlyi szm alapjn
	public void removeSzemelyBySzemSzam(String szsz){
		removeSzemely(getSzemelyBySzemSzam(szsz));
	}
	
	//szemly(ek) eltvoltsa nv alapjn
	public void removeSzemelyByNev(String nev){
		Vector v=getSzemelyByNev(nev);
		for(int i=0;i<v.size();i++){
			removeSzemely((Szemely)v.get(i));
		}
	}

// ----------------- mdosts -----------------------
	
	//szemly nevnek mdostsa
	public void modifySzemelyNev(String szsz, String nev){
		Szemely sz= getSzemelyBySzemSzam(szsz);
		if(sz!=null) sz.setNev(nev);
	}
	
// ---------------- listzs -------------------------
	
	//listzs szemlyi szm szerint
	public void listazasSzemSzamSzerint(){
		Iterator it=d.iterator();
		while(it.hasNext()){
			System.out.println(it.next());
		}
	}
	
	//listzs nv szerint
	public void listazasNevSzerint(){
		TreeSet ts=new TreeSet(nevSzerint);
		ts.addAll(d);
		Iterator it=ts.iterator();
		while(it.hasNext()){
			System.out.println(it.next());
		}
	}
		
	//listzs szletsi dtum szerint
	public void listazasSzulDatumSzerint(){
		TreeSet ts=new TreeSet(SzulDatumSzerint);
		ts.addAll(d);
		Iterator it=ts.iterator();
		while(it.hasNext()){
			System.out.println(it.next());
		}
	}
	
// ------------------ rendezsi belltsok -------------------	
	
	//nv szerinti sorbarendezshez
	static final Comparator nevSzerint=new Comparator(){
		public int compare(Object o1, Object o2){
			//azrt szksges a szemszm hozzfzse is, mert nv egyezs esetn a Set miatt egyik elveszne
			String s1=((Szemely)o1).getNev()+((Szemely)o1).getSzemSzam();
			String s2=((Szemely)o2).getNev()+((Szemely)o2).getSzemSzam();
			return s1.compareTo(s2);
		}
	};
	
	//szletsi dtum szerinti sorbarendezshez
	static final Comparator SzulDatumSzerint=new Comparator(){
		public int compare(Object o1, Object o2){
			//azrt szksges a szemszm hozzfzse is, mert szletsi dtum egyezs esetn a Set miatt egyik elveszne
			String s1=((Szemely)o1).getSzemSzam().substring(2,8)+((Szemely)o1).getSzemSzam();
			String s2=((Szemely)o2).getSzemSzam().substring(2,8)+((Szemely)o2).getSzemSzam();
			return s1.compareTo(s2);
		}
	};
	
}