/*
	Tesztprogram a pufferezett, ill. pufferezetlen IO teljestmny mrsre
*/
import java.io.*;

public class FileBufferBenchmark {
	public static void main(String[] args) throws Exception {
		// elszr puffer nlkli rs szzezerszer
		long startIdo= System.currentTimeMillis(); 
		DataOutputStream kimenet = new DataOutputStream(new FileOutputStream("data.bin"));
		for(int i = 0; i < 100000; i++) {
			kimenet.writeLong(Long.MAX_VALUE);
		}
		kimenet.close();
		System.out.println("Kiirs puffer nlkl: " + (System.currentTimeMillis() - startIdo) + " ms.");

		// msodszor pufferezett rs szzezerszer
		startIdo= System.currentTimeMillis();
		kimenet = new DataOutputStream(new BufferedOutputStream(new FileOutputStream("data.bin")));
		for(int i = 0; i < 100000; i++) {
			kimenet.writeLong(Long.MAX_VALUE);
		}
		kimenet.close();
		System.out.println("Kiirs pufferrel: " + (System.currentTimeMillis() - startIdo) + " ms."); 

		// beolvass puffer nlkl
		DataInputStream bemenet = new DataInputStream(new FileInputStream("data.bin"));
		startIdo= System.currentTimeMillis();
		for(int i = 0; i < 100000; i++) {
			bemenet.readLong();
		}
		bemenet.close();
		System.out.println("Beolvass puffer nlkl: " + (System.currentTimeMillis() - startIdo) + " ms."); 

		// beolvass pufferezetten
		startIdo= System.currentTimeMillis();
		bemenet = new DataInputStream(new BufferedInputStream(new FileInputStream("data.bin")));
		for(int i = 0; i < 100000; i++) {
			bemenet.readLong();
		}
		bemenet.close();
		System.out.println("Beolvass pufferrel: " + (System.currentTimeMillis() - startIdo) + " ms."); 
	}
}