/*
	Adatok szerializcija, Serializable interfsz hasznlata
*/
import java.io.*;

public class AdatFajl {
	Tarolo t1, t2;

	public void olvas() throws IOException {
		int i, n;
		double d;
		String s;

		StreamTokenizer st = new StreamTokenizer(new BufferedReader(new InputStreamReader(System.in)));
		System.out.print("Egsz rtk: ");
		while(st.nextToken() != st.TT_NUMBER) {
			System.out.println("Hibs adat!");
		}
		i = (int)st.nval;
		System.out.print("Vals rtk: ");
		while(st.nextToken() != st.TT_NUMBER) {
			System.out.println("Hibs adat!");
		}
		d = st.nval;
		System.out.print("Sz: ");
		while(st.nextToken() != st.TT_WORD) {
			System.out.println("Hibs adat!");
		}
		s = st.sval;
		System.out.print("Amit nem kell menteni: ");
		while(st.nextToken() != st.TT_NUMBER) {
			System.out.println("Hibs adat!");
		}
		n = (int)st.nval;
		t1 = new Tarolo(i, d, s, n);
	}

	public void fajlIras(String nev) throws IOException, FileNotFoundException {
		ObjectOutputStream oos = new ObjectOutputStream(new FileOutputStream(nev));
		oos.writeObject(t1);
		oos.close();
	}

	public void fajlOlvasas(String nev) throws IOException, FileNotFoundException, ClassNotFoundException {
		ObjectInputStream ois = new ObjectInputStream(new FileInputStream(nev));
		t2 = (Tarolo)ois.readObject();
		ois.close();
	}

	public static void main(String[] args) {
		AdatFajl a = new AdatFajl();
		final String fajl = "adatfajl.bin";
		try {
			a.olvas();
			System.out.println("Felhasznl ltal adott rtkek:\n" + a.t1);
			a.fajlIras(fajl);
			a.fajlOlvasas(fajl);
		} catch(FileNotFoundException e) {
			System.err.println("Fjl nem tallhat: " + e);
		} catch(IOException e) {
			System.err.println("B/K hiba: " + e);
		} catch(ClassNotFoundException e) {
			System.err.println("Nincs ilyen osztly: " + e);
		}
		System.out.println("Visszaolvasott rtkek:\n" + a.t2);
	}
}