import java.io.*;
import java.util.*;

public class Nevnap implements Serializable{
	private TreeMap data;
	private static Nevnap n;
	
	public static void main(String[] args){
		n=new Nevnap();
		try{
			//n.fajlOlvasas("nevnapdata.bin");
		}
		catch(Exception ex){
			System.out.println("Hiba trtnt: "+ex);
		}
		n.getDatumok("nevek-datumok.txt");
		n.getNemek("nevek-nemek.csv");
		System.out.println("Csaba nvnapja: "+n.getNevnap("Csaba"));
		System.out.println("Melinda nvnapja: "+n.getNevnap("Melinda"));
		System.out.println("Pl nvnapja: "+n.getNevnap("Pl"));
		
		System.out.println("Pl neme: "+n.getNem("Pl"));
		System.out.println("Melinda neme: "+n.getNem("Melinda"));
		
		try{
			n.fajlIras("nevnapdata.bin");			
		}
		catch(Exception ex){
			System.out.println("Hiba trtnt: "+ex);
		}
	}
	
	public Nevnap(){
		data=new TreeMap();
	}
	
	private void getDatumok(String fajl){
		try{
			BufferedReader f = new BufferedReader(new FileReader(fajl));
			String sor;
			while((sor = f.readLine()) != null) {
				String[] tomb = sor.split("\t");
				String[] nevek = tomb[1].split(",");
				for(int i=0;i<nevek.length;i++){
					String nev=nevek[i].trim();
					if(data.containsKey(nev)){
						String old=((DatumNem)data.get(nev)).getDatum();
						String uj=old+", "+tomb[0];
						data.put(nev,new DatumNem(uj,false));						
						//System.out.println(nev+"--"+getNevnap(nev));
					}
					else	data.put(nev,new DatumNem(tomb[0],false));
				}
			}
			f.close();
		}
		catch(IOException ex){
			System.out.println("Hiba trtnt a dtumok beolvassa sorn!");
		}
	}
	
	private void getNemek(String fajl){
		try{
			BufferedReader f = new BufferedReader(new FileReader(fajl));
			String sor;
			while((sor = f.readLine()) != null) {
				String[] tomb = sor.split(";");				
				DatumNem nev=(DatumNem)data.get(tomb[0]);
				if(nev!=null){
					//System.out.println(tomb[0]+"-"+tomb[1]);
					if(tomb[1].equals("1")) //frfi
						nev.setNem(true);
					else //n
						nev.setNem(false);
				}
			}
			f.close();
		}
		catch(IOException ex){
			System.out.println("Hiba trtnt a nemek beolvassa sorn!");
		}
	}
	
	private String getNevnap(String nn){
		return ((DatumNem)data.get(nn)).getDatum();
	}
	
	private String getNem(String nn){
		return ((DatumNem)data.get(nn)).getNem()?"frfi":"n";
	}
	
	public void fajlIras(String nev) throws IOException, FileNotFoundException {
		ObjectOutputStream oos = new ObjectOutputStream(new FileOutputStream(nev));
		oos.writeObject(n);
		oos.close();
	}
	
	public void fajlOlvasas(String nev) throws IOException, FileNotFoundException, ClassNotFoundException {
		ObjectInputStream ois = new ObjectInputStream(new FileInputStream(nev));
		n = (Nevnap)ois.readObject();
		ois.close();
	}
}

class DatumNem implements Serializable{
	private String datum;
	private boolean nem; //true: frfi, false: n
	
	public DatumNem(String d, boolean b){
		datum=d;
		nem=b;
	}
	
	public String getDatum(){
		return datum;
	}
	
	public boolean getNem(){
		return nem;
	}
	
	public void setNem(boolean b){
		nem=b;
	}
	
	public String toString(){
		return "Nvnap: "+datum+", "+(nem?"frfi":"n");
	}
}