/*
	Egy URL-lel azonostott objektumrl
	informcik kirsa egy hozza tartoz
	URLConnection objektum segtsgvel.

	Ez az alkalmazs az argumentumban megadott URL-lel
	azonostott objektumrl informcikat szolgltat oly mdon,
	hogy ltrehoz egy URLConnection kapcsolatot a megadott
	objektummal, s sok mindent kir.

	A program paramtere: a letltend URL azonostja (pl. egy fjlnv)

	Egy plda a futtatsra:
	java URLCTest ftp://localhost/macska

	Forrs: JAVA2 tikalauz programozknak
*/
import java.io.*;
import java.net.*;
import java.util.*;

public class URLCTest {
	public static void hasznalati_utasitas() {
		System.out.println("Hasznlat: java URLCTest URL");
		System.exit(-1);
	}

	public static void URL_informaciok(String cim)
	throws MalformedURLException, IOException {
		URL url_objektum = new URL(cim);
		URLConnection url_kapcsolat = url_objektum.openConnection();
		System.out.println("URL: " + cim);
		System.out.println(" Tartalom tpusa: " +
			url_kapcsolat.getContentType());
		System.out.println(" Tartalom mrete: " +
			url_kapcsolat.getContentLength());
		System.out.println(" Utols mdosts: " +
			new Date(url_kapcsolat.getLastModified()));
		System.out.println("-------------------------------------------------");
		// Most lapozva kirjuk a tartalmat
		BufferedReader tartalom = new BufferedReader(
			new InputStreamReader(url_kapcsolat.getInputStream()));
		boolean fajlvege = false;
		int sorszam = 4;
		BufferedReader input = new BufferedReader(new InputStreamReader(System.in));

		while(!fajlvege) {
			String egysor = tartalom.readLine();
			if(egysor == null) {
				fajlvege=true;
			} else {
				System.out.println(egysor);
			}
			sorszam++;
			if((sorszam % 23) == 22) {
				System.out.println("A RETURN billenty lenyomsa lapoz!");
				input.readLine();
			}
		}
	}

	public static void main(String[] args) {
		if (args.length != 1) {
			hasznalati_utasitas();
		}
		try {
			URL_informaciok(args[0]);
		} catch(MalformedURLException e) {
			System.err.println("Hibs URL!");
		} catch (IOException e) {
			System.err.println("Nem sikerlt a letlts!");
		}
	}
}