/*
	URLTest.java - egy URL-lel azonostott objektum letltse a hlzatrl.

	Ez az alkalmazs letlt egy, az els s 
	egyetlen argumentumban megadott 
	URL-lel azonostott objektumot.

	Egy plda a futtatsra:

	java URLTest ftp://localhost/macska
	java URLTest http://szt1.sze.hu/java/

	Forrs: JAVA2 tikalauz programozknak
*/
import java.io.*;
import java.net.*;

public class URLTest {
	public static void hasznalati_utasitas() {
		System.out.println("Hasznlat: java URLTest URL");
		System.exit(-1);
	}

	public static Object kinyeri_az_adatot_az_URL_bol(String cim)
	throws MalformedURLException, IOException {
		URL url_objektum = new URL(cim);
		return url_objektum.getContent();
	}

	public static void main(String[] args) {
		if(args.length != 1) {
			hasznalati_utasitas();
		}
		Object obj = "Nincs mit kiirnom.";
		try {
			obj = kinyeri_az_adatot_az_URL_bol(args[0]);
		} catch(MalformedURLException e) {
			System.err.println("Hibs URL!");
		} catch (IOException e) {
			System.err.println("Nem sikerlt a letlts!");
		}
		try {
			System.out.println((String)obj);
		} catch(ClassCastException e) {
			if (obj instanceof InputStream) {
				try {
					BufferedReader tartalom = new BufferedReader
					(new InputStreamReader((InputStream)(obj)));
					boolean fajlvege = false;
					while(!fajlvege) {
						String egysor = tartalom.readLine();
						if(egysor == null) {
							fajlvege = true;
						} else {
							System.out.println(egysor);
						}
					}
				} catch(IOException ie) {
					System.out.println("Hiba trtnt a tartalom letltsekor!");
				}
			} else {
				System.out.println("Nem sikerlt a tartalom kirhat formra konvertlsa!");
				System.out.println("A kapott objektum osztlya:");
				System.out.println(obj.toString());
			}
		}
	}
}