/*
	ClClTest.java - Egy sszekttets-mentes kliens alkalmazs

	Ez az alkalmazs csomagot kld az argumentumaiban megadott nev
	szmtgp megadott sorszm UDP portjra, a csomagban egy sz van,
	amit a felhasznl a harmadik argumentumban adhat meg.

	A programparamterek:
	Els:		annak a hosztnak a neve, ahol a szerver fut
	Msodik:	a szerver UDP portjnak a sorszma
	Harmadik:	a szervernek tkldend sz, vagy szveg

	Plda a futtatsra:
	java ClClTest localhost 5678 Szia_Alma! 
	java ClClTest localhost 5678 "Hello ez itt egy zenet!"

	Forrs: JAVA2 tikalauz programozknak
*/
import java.io.*;
import java.net.*;

public class ClClTest {
	public static void hasznalati_utasitas() {
		System.out.println("Hasznlat: java ClClTest " +
			"szmtgpnv portsorszm tkldend-sz");
		System.exit(-1);
	}

	public static void main(String[] args) {
		try {
			// parancssori parmtrek ellenrzse
			if(args.length != 3) {
				hasznalati_utasitas();
			}

			int server_port = 0;
			try {
				server_port = Integer.parseInt(args[1]);
			} catch(NumberFormatException e) {
				hasznalati_utasitas(); 
			}

			System.out.println("A kliens indul.");
			// kommunikcis vgpont ltrehozsa (ha lehetsges)
			DatagramSocket s = new DatagramSocket();
			System.out.println("A kliens kommunikcira ksz.");
			// programparamterek msolsa
			try {

				// A szerver cmnek kidertse
				InetAddress ip_cim = InetAddress.getByName(args[0]);
				// az zenet hossza
				int uzenet_hossz = args[2].length();
				// az zenet konverlsa bjttmbbe
				byte[] uzenet = args[2].getBytes();
				System.out.println("Csomag sszelltsa.");
				// az UDP csomag sszelltsa
				DatagramPacket p = new DatagramPacket(uzenet, uzenet_hossz,
					ip_cim, server_port);

				// elkldjk a csomagot a kommunikcis vgpontrl
				s.send(p);
				System.out.println("A csomagot elkldtem.");
				// hibakezels
			} catch(UnknownHostException e) {
				System.err.println("Ismeretlen hoszt!"); 
			} catch(IOException e) {
				System.err.println("Nem sikerlt a klds!"); 
			// megszntetjk a kommunikcis vgpontunkat
			} finally { 
				s.close(); 
				System.out.println("A kliens lezrta a kommunikcit.");
			} 
		// ha nem sikerlt UDP socketet foglalni
		} catch (SocketException e) {
			System.err.println("UDP port lefoglalsa nem sikerlt!"); 
		}
	}
}