/*
	ClSeTest.java - Egy sszekttets-mentes szerver alkalmazs

	Ez az alkalmazs csomagot fogad a futtat szmtgp
	megadott sorszm UDP portjrl, a csomag tartalmat pedig
	kirja. 

	A programparamter: a szerver UDP portjnak a sorszma

	Egy plda a futtatsra:
	java ClSeTest 5678

	Forrs: JAVA2 tikalauz programozknak
*/
import java.io.*;
import java.net.*;

public class ClSeTest {
	public static void hasznalati_utasitas() {
		System.out.println("Hasznlat: java ClSeTest " +
			"portsorszm");
		System.exit(-1);
	}

	public static void main(String[] args) {
		// sok vagy kevs argumentum
		if(args.length != 1) {
			hasznalati_utasitas();
		}

		//A szerver port-sorszma
		int server_port = 0;
		try {
			server_port = Integer.parseInt(args[0]);
		} catch(NumberFormatException e) {
			hasznalati_utasitas(); 
		}

		// zenet fogadsa
		System.out.println("A szerver indul.");
		try {
			// helyet csinlunk az zenetnek
			byte[] uzenet = new byte[1500]; 
			// hely a Stringg konvertlt zenetnek (szksges,
			// ugyanis Stringknt akarjuk kiratni, gy konvertlni kell majd)
			String szoveg; 

			// Ltrehozunk egy csomagot, ahova a berkez zenetet tesszk
			DatagramPacket p = new DatagramPacket(uzenet, uzenet.length);

			// Ltrehozzuk a szerver kommunikcis vgpontot
			// a megadott UDP porton
			DatagramSocket s = new DatagramSocket(server_port);
			System.out.println("Vrakozs az adatcsomagra.");
			// vrunk egy csomagot, s a tartalmt beolvassuk p-be
			s.receive(p); 

			System.out.println("Adatcsomag rkezett a "+
				p.getAddress().getHostName() +" szmtgptl, a(z) " +
				p.getPort() + ". szm UDP portrl.");
			// a kapott zenet tartalmt Stringg konvertljuk
			szoveg = new String(uzenet, 0, p.getLength()); 
			// s kirjuk
			System.out.println("Az zenet tartalma: " + szoveg);
			// kommunikcis vgpont lezrsa
			s.close();
			System.out.println("A szerver lell.");
		} catch(UnknownHostException e) {
			System.err.println("Ismeretlen hoszt!"); 
		} catch (IOException e) {
			System.err.println("Nem sikerlt a klds!"); 
		}
	}
}