/*
	CoClTest.java - Egy sszekttets alap kliens alkalmazs

	Ez az alkalmazs felveszi az argumentumaiban megadott nev szmtgp
	megadott sorszm TCP portjval a kapcsolatot, s tkld oda egy
	pozitv numerikus rtket, amit a szerver feldolgoz (a jelenlegi
	szerver implementci egyszeren ngyzetre emeli), s visszakldi a
	kapott eredmnyt.

	A programparamterek:
	Els:		annak a gpnek a neve, ahol a szerver fut
	Msodik:	a szerver TCP portjnak a sorszma
	Harmadik:	a szervernek tkldend szm (ezt emeli ngyzetre)

	Egy plda a futtatsra:
	java CoClTest localhost 5678 56

	Forrs: JAVA2 tikalauz programozknak
*/
import java.io.*;
import java.net.*;

public class CoClTest {
	public static int ATKULDENDO_ERTEK ;

	public static void hasznalati_utasitas() {
		System.out.println("Hasznlat: java CoClTest " +
			"szmtgpnv portsorszm szm");
		System.exit(-1);
	}

	public static void main(String[] args) {
		if(args.length != 3) {
			hasznalati_utasitas();
		}

		// a felkeresni kvnt gp nyitott portja
		int server_port = 0;
		// a kapcsolds fellete
		Socket s = null;
		String valasz = null;

		// az rkez adatok konvertlsa
		try {
			server_port = Integer.parseInt(args[1]);
		} catch(NumberFormatException e) {
			hasznalati_utasitas();
		}
		try {
			ATKULDENDO_ERTEK = Integer.parseInt(args[2]); 
		} catch(NumberFormatException e) {
			hasznalati_utasitas(); 
		}

		// a kommunikci
		try {
			// Ltrehozzuk a kommunikcis vgpontunkat
			System.out.println("Kapcsolat felptse.");
			s = new Socket(args[0], server_port);
			// Ezzel tudunk a kommunikcis vgpontunkrl adatot olvasni:
			BufferedReader input = new BufferedReader(
				new InputStreamReader(s.getInputStream()));
			// Ezzel tudunk a kommunikcis vgpontunkra adatot rni:
			PrintWriter output = new PrintWriter(s.getOutputStream());

			output.println(Integer.toString(ATKULDENDO_ERTEK));
			// adatok elkldse
			output.flush();
			System.out.println("A kldtt adat: " + ATKULDENDO_ERTEK);
			// Megvrjuk a szerver vlaszt
			System.out.println("Vrakozs vlaszra...");
			valasz = input.readLine(); 

			// Kirjuk az eredmnyt
			System.out.println("Adat rkezett!\nAz elkldtt szm ngyzete: " + valasz + ".");

		// hibakezels
		} catch(IOException e) {
			// Kirtuk a hiba okt...
			System.err.println(e);
		// Lezrjuk a kommunikcis vgponthoz tartoz socketot...
		} finally {
			try { 
				s.close(); 
				System.out.println("A kliens lezrja a kapcsolatot.");
			} catch(Exception ex) {
				System.err.println("Nem tudom lezrni a kapcsolatot!");
			}
		}
	}
}