/*
	CoSeTest.java - Egy sszekttets alap szerver alkalmazs

	Ez az alkalmazs az egyetlen paramterben megadott sorszm TCP
	porton vrakozik kliens alkalmazsok rkapcsoldsi krelmre. Ha
	egy kliens rkapcsoldik, akkor vr tle egy pozitv egsz szmot,
	s ngyzetre emelve visszakldi a kapott eredmnyt.
	Ez egy szekvencilis szerver, vagyis a klienseket egyms utn
	szolglja ki (azaz ha egy kliens sokig nem kld adatot, akkor
	a szerver addig vrakozni fog...).
	A szerver lell, ha 0 szmot kld egy kliens (de a 0-t ngyzetre 
	emelve visszakldi a kliensnek ilyenkor is).

	A programparamter: a szerver TCP portjnak a sorszma

	Egy plda a futtatsra:
	java CoSeTest 5678

	Forrs: JAVA2 tikalauz programozknak
*/
import java.io.*;
import java.net.*;

public class CoSeTest {
	public static void hasznalati_utasitas() {
		System.out.println("Hasznlat: java CoSeTest portsorszm");
		System.exit(-1);
	}

	public static void main(String[] args) {
		int server_port = 0;
		ServerSocket ss = null;
		Socket s = null;
		String keres = null, valasz = null;
		int keres_erteke = 0;
		boolean kilep = false;

		if(args.length != 1) {
			hasznalati_utasitas();
		}
		try {
			server_port = Integer.parseInt(args[0]);
		} catch(NumberFormatException e) {
			hasznalati_utasitas();
		}

		System.out.println("A szerver elindult.");
		try {
			// Ltrehozzuk a kommunikcis vgpontunkat
			ss = new ServerSocket(server_port);
			System.out.println("Vrakozs a kliensre.");
			while(!kilep) {
				/*
					Felvesszk a kapcsolatot a kvetkez klienssel
					A szerver itt vrakozik egy j kliensre, ha kell. 
					Ha kliens rkezik akkor egy konkrt socketet rendel a kapcsolathoz
				*/
				s = ss.accept();
				System.out.println("Kliens rkezett!");
				// Ezzel tudunk a kommunikcis vgpontunkrl adatot olvasni:
				BufferedReader input = new BufferedReader(
					new InputStreamReader(s.getInputStream()));
				// Ezzel tudunk a kommunikcis vgpontunkra adatot rni:
				PrintWriter output = new PrintWriter(s.getOutputStream());
	
				// Itt kezddik a szolgltats-fgg kdrszlet
				// az rkez szm ngyzetnek ellltsa
				keres = input.readLine();
				System.out.println("A berkezett krs: "+keres);
				try {
					keres_erteke = Integer.parseInt(keres);
					valasz = Integer.toString(keres_erteke * keres_erteke);
				} catch(NumberFormatException e) {
					valasz = "rvnytelen adat!"; 
				}
				System.out.println("A visszakldtt vlasz: " + valasz);
				// Visszakldjk a kliensnek az eredmnyt
				output.println(valasz);
				output.flush();
				// 0-ra lelltjuk a szervert
				if(keres_erteke == 0) {
					kilep = true;
				}
				System.out.println("Kapcsolat lezrs.");
				// Itt fejezdik be a szolgltats-fgg kdrszlet
				// a kapcsolat lezrsa
				s.close();
			}
		} catch(IOException e) {
			// Kirtuk a hiba okt...
			System.err.println(e);
		} finally {
			// Lezrjuk a kommunikcis vgponthoz tartoz socketot...
			try {
				ss.close(); 
				System.out.println("A szerver lellt.");
			} catch(IOException ex) {
				System.err.println("Nem tudom lezrni a kapcsolatot!");
			}
		}
	}
}