/*
	Egyszer csevegprogram

	Futtats: java Chat [zemmd] [port]
	zemmd: "kliens" vagy "szerver", alaprtelmezs: "kliens"
	port: alaprtelmezs szerint 5678
*/
import java.net.*;
import java.io.*;

public class Chat {
	private String host;
	private int port;
	final int SZERVER = 0;
	final int KLIENS = 1;
	private int uzemmod;
	final String[] megnev = {"szerver", "kliens"};
	Socket s;

	public static void main(String[] args) {
		Chat c1 = new Chat(args);
		System.out.println(c1);
		c1.start();
	}

	public Chat(String[] parameterek) {
		uzemmod = KLIENS;
		host = "localhost";
		port = 5678;
		String s;
		for(int i = 0; i < parameterek.length; i++) {
			if((s = parameterek[i].toLowerCase()).compareTo("kliens") == 0) {
				uzemmod = KLIENS;
			} else if(s.compareTo("szerver") == 0) {
				uzemmod = SZERVER;
			} else {
				try {
					port = Integer.parseInt(s);
				} catch(NumberFormatException e) {
					host = s;
				}
			}
		}
	}

	public String toString() {
		return "zemmd: " + megnev[uzemmod] +
			"\nGp: " + host + "\nPort: " + port;
	}

	void kommunikacio() {
		boolean kilep = false;
		System.out.println("Kapcsolat felplt...");
		try {
			BufferedReader r_input = new BufferedReader(
				new InputStreamReader(s.getInputStream()));
			BufferedReader l_input = new BufferedReader(
				new InputStreamReader(System.in));
			PrintWriter output = new PrintWriter(s.getOutputStream());
			while(!kilep) {
				try {
					String str = "";
					if(r_input.ready()) {
						str = r_input.readLine();
						System.out.println(megnev[1 - uzemmod] + ": " + str);
					}
					if(l_input.ready()) {
						str = l_input.readLine();
						output.println(str);
						output.flush();
					}
					if(str.compareTo("vege") == 0) {
						kilep = true;
						s.close();
					}
				} catch(IOException e) {
					System.err.println(e);
				}
			}
		} catch(IOException e) {
			System.err.println("Folyamok ltrehozsa sikertelen: " + e);
		}
	}

	void start() {
		if(uzemmod == SZERVER) {
			try {
				ServerSocket ss = new ServerSocket(port);
				System.out.println("Vrakozs a kliensre...");
				s = ss.accept();
				kommunikacio();
				ss.close();
			} catch(IOException e) {
				System.err.println(e);
			}
		} else {
			// Kliens
			try {
				s = new Socket(host, port);
				kommunikacio();
			} catch(IOException e) {
				System.err.println("Szerver nem ll kszen: " + e);
			}
		}
	}
}