
import java.util.*;

/**
 * Jtk vezrls, jtkos nyilvntarts,
 * szablyok, pontozs, eredmny hirdets
 * @author Varjasi Norbert
 */
public class JatekVezerlo {

    /**
     * hny krs a verseny?
     */
    private int fordulo;
    /**
     * A jtkosok listja
     */
    private Vector<Jatekos> jatekosok;
    /**
     * A pontok szmtshoz tartoz lekpezs
     */
    private TreeMap<Jatekos, Integer> pontok;

    /**
     * A jtkvezrl konstruktora
     * @param fordulo a jtk hny darab jtszmbl lljon?
     */
    public JatekVezerlo(int fordulo) {
        this.fordulo = fordulo;
        jatekosok = new Vector<Jatekos>();
        pontok = new TreeMap<Jatekos, Integer>();

    }

    /**
     * Jtkos hozzadsa a jtkhoz, pontjainak nullzsa
     * @param uj az rkez j jtkos
     */
    public void addJatekos(Jatekos uj) {
        jatekosok.add(uj); // j szerepl erkezik a jatkba
        pontok.put(uj, 0); // nulla pontrl indul mindenki
    }

    /**
     * Megllaptja, hogy pros szm versenyz nevezett-e a jtkba
     * @return pros-e a lista elemszma
     */
    private boolean indulhat() {
        //akkor indulhat a jtk, ha pros szm rsztvev van
        return (jatekosok.size()%2 == 0);
    }

    /**
     * Jtk indtsa
     * pratlan rsztvev esetn egy gpi jtkos beillesztsvel indtja a fordulkat
     */
    public void startJatek() {
        if (!indulhat()) {
            System.out.println("Nincs elegend jtkos, a gp is beszll!");
            addJatekos(new Jatekos("gp"));// j jtkos hozzadsa

        }
        //jtszma indtsa
        //pontok.clear();
        fordulok();
    }

    /**
     * a jtk krkre osztsa s a krkben a jtkosprok pros jtszmi
     */
    private void fordulok() {
        Jatekos elso, masodik, nyero;
        System.out.println("Jtkos prok " + fordulo + " krs jtka kvetkezik.");
        for (int i = 0; i < fordulo; i++) {
            int j = 0;

            //Egy pr jtkos bemondja a vlasztst
            while (j < jatekosok.size()) {

                elso = jatekosok.get(j);
                masodik = jatekosok.get(j + 1);  // a mellette lev jtkos
                nyero = egyjatszma(elso, masodik);

                // ha nem dntetlen egy jtk, a pontot jvrjuk
                if (nyero != null) {
                    pontok.put(nyero, pontok.get(nyero) + 1);
                    System.out.println("    pontot kapott: " + nyero);
                }
                // a kvetkez pr jhet
                j += 2;

            }


        }//for i
    }

    /**
     * Egy k-papr-oll jtszma
     * Kt jtkos bemondja a vlsztst, majd eldntjk, ki a nyertes
     * @param elso jtkos
     * @param masodik jtkos
     * @return nyertes jtkos
     */
    private Jatekos egyjatszma(Jatekos elso, Jatekos masodik) {
        //a kt versenyz mutat egy figurt
        Bemondas bemondas1 = elso.mutat();
        Bemondas bemondas2 = masodik.mutat();
        //kirs
        System.out.print("  " + elso + " " + bemondas1 + ", " + masodik + " " + bemondas2);
        //dnts, hogy ki nyeri a jtszmt?
        //dntetlen eset
        if (bemondas1.equals(bemondas2)) { 
            System.out.println(" dntetlen");
            return null;
        //esl nyer
        } else if ((bemondas1.equals(Bemondas.KO) && bemondas2.equals(Bemondas.OLLO))
                || (bemondas1.equals(Bemondas.PAPIR) && bemondas2.equals(Bemondas.KO))
                || (bemondas1.equals(Bemondas.OLLO) && bemondas2.equals(Bemondas.PAPIR))) {
            System.out.println(": nyerte: " + elso);
            return elso;
        //msodik nyer
        } else {
            System.out.println(": nyerte: " + masodik);
            return masodik;
        }

    }

    /**
     * Vgeredmny kiolvassa
     * @return a vgeredmny szvegesen
     */
    public String eredmeny() {
        StringBuffer sb = new StringBuffer(" A " + fordulo + " krs jtk vgeredmnye:\n");
        //jtkosok bejrsa
        for (Jatekos j : jatekosok) {
            sb.append("\t").append(j).append(", eredmnye: ")
                    .append(pontok.get(j)).append(" pont.\n");
        }

        return sb.toString();

    }

    /**
     * Jtkoslista sorrendbe rendezse, vagy vletlenszer keverse
     * @param nevsorba true esetn nvsorba rendez
     */
    public void jatekosSorrend(boolean nevsorba) {
        if (nevsorba) {
            Collections.sort(jatekosok);
        } else {
            Collections.shuffle(jatekosok);
        }
    }
}
